#############################################################################
##
#A  toric.gi                  GUAVA library                      David Joyner
##
##  this file contains implementations for toric codes
##
#H  @(#)$Id: toric.gi,v 1.1 2003/02/27 22:45:16 gap Exp $
##
Revision.("guava/lib/toric_gi") :=
    "@(#)$Id: toric.gi,v 1.1 2003/02/27 22:45:16 gap Exp $";

#############################################################################
##
#F  ToricPoints(<n>,<F>)
##
InstallGlobalFunction(ToricPoints,function(n,F)
local T,L,i,x0;
  T:=[];
  for x0 in AsList(F ) do
  if x0<>Zero(F) then Add(T,x0); fi;
  od;
  L:=Cartesian(List([1..n],i->T));
  return L;
end);

#############################################################################
##
#F  ToricCode(<L>,<F>)
##
InstallGlobalFunction(ToricCode,function(L,F)
local u,gens,d,V,n,i,Z,v,B0,B,C,C1,t,e,tmpvar;
  gens:=L;
  d:=Size(gens[1]);
  n:=Size(ToricPoints(d,F));
  V:=F^n;         # VectorSpace(F,n);
  Z:=Integers;
  B0:=[];
  e:=gens[1];
  for e in gens do
  tmpvar:=List(ToricPoints(d,F),t->Product([1..d],i->t[i]^e[i]));
  Add(B0,tmpvar);
  od;
  B:=AsList(B0);
  C:=GeneratorMatCode(One(F)*B,F); ##uses guava command
  return C;
end);

# for compatibility ...
BindGlobal("ToricCodewords",function(L,F)
  return Elements(ToricCode(L,F));
end);
