#############################################################################
##
#A  upperbd3.g 		        GUAVA library                   Reinald Baart
#A                                                       & Jasper Cramwinckel
#A                                                          & Erik Roijackers
##
##  This file contains a reference and an upper bound on the minimum distance
##  of a linear code over GF(3) of given word length and dimension.
##
#H  @(#)$Id: upperbd3.g,v 1.1.1.1 1998/03/19 17:31:45 lea Exp $
##
#Y  Copyright (C)  1994,  Vakgroep Algemene Wiskunde,  T.U. Delft,  Nederland
##
#H  $Log: upperbd3.g,v $
#H  Revision 1.1.1.1  1998/03/19 17:31:45  lea
#H  Initial version of GUAVA for GAP4.  Development still under way. 
#H  Lea Ruscio 19/3/98
#H
#H
#H  Revision 1.2  1997/01/20 15:34:43  werner
#H  Upgrade from Guava 1.2 to Guava 1.3 for GAP release 3.4.4.
#H
#H  Revision 1.1  1994/11/10  14:29:23  rbaart
#H  Initial revision
#H
##
GUAVA_TEMP_VAR := [ 
[  15,   8,   5, "vE" ],
[  15,   9,   4, "vE" ],
[  16,   6,   7, "vE" ],
[  16,   7,   6, "vE" ],
[  21,   4,  12, "HN" ],
[  21,  16,   3, "Ga" ],
[  25,  13,   8, "LP" ],
[  29,   6,  16, "vE" ],
[  33,  18,   9, "LP" ],
[  33,  26,   4, "BKn" ],
[  37,  12,  17, "LP" ],
[  40,  27,   8, "LP" ],
[  41,   5,  25, "HN" ],
[  42,  21,  14, "BKn" ],
[  47,  13,  23, "BKn" ],
[  47,  17,  20, "LP" ],
[  50,  28,  14, "BKn" ],
[  51,   5,  32, "HHY" ],
[  51,  40,   6, "BKn" ],
[  53,  39,   8, "BKn" ],
[  54,  28,  17, "LP" ],
[  55,  12,  29, "LP" ],
[  55,  16,  26, "BKn" ],
[  55,  30,  16, "BKn" ],
[  56,   9,  32, "LP" ],
[  56,  39,  10, "LP" ],
[  57,  11,  31, "BKn" ],
[  57,  49,   4, "BKn" ],
[  58,   7,  35, "BKn" ],
[  58,  13,  30, "LP" ],
[  59,  24,  23, "BKn" ],
[  60,  10,  34, "BKn" ],
[  60,  11,  33, "BKn" ],
[  60,  22,  25, "BKn" ],
[  60,  40,  12, "BKn" ],
[  61,  17,  29, "BKn" ],
[  61,  30,  20, "LP" ],
[  62,  14,  32, "BKn" ],
[  63,  11,  35, "BKn" ],
[  64,  17,  31, "BKn" ],
[  64,  30,  22, "BKn" ],
[  64,  38,  16, "BKn" ],
[  65,  14,  34, "BKn" ],
[  65,  41,  15, "BKn" ],
[  65,  42,  14, "BKn" ],
[  66,  26,  26, "BKn" ],
[  67,   7,  41, "BKn" ],
[  67,  17,  33, "BKn" ],
[  67,  38,  18, "BKn" ],
[  69,  16,  35, "LP" ],
[  69,  20,  32, "BKn" ],
[  69,  51,  10, "BKn" ],
[  69,  54,   8, "BKn" ],
[  70,   6,  44, "vEH" ],
[  70,   7,  43, "Da" ],
[  70,   8,  42, "LP" ],
[  70,  14,  37, "BKn" ],
[  70,  37,  21, "LP" ],
[  71,  35,  23, "LP" ],
[  71,  39,  20, "BKn" ],
[  71,  50,  12, "BKn" ],
[  72,   5,  46, "HN" ],
[  72,  11,  41, "Da" ],
[  72,  20,  34, "BKn" ],
[  72,  33,  25, "LP" ],
[  73,   8,  44, "LP" ],
[  73,  13,  40, "LP" ],
[  73,  14,  39, "BKn" ],
[  73,  28,  29, "BKn" ],
[  73,  38,  22, "LP" ],
[  74,  11,  42, "Da" ],
[  74,  23,  33, "BKn" ],
[  74,  26,  31, "BKn" ],
[  74,  62,   6, "BKn" ],
[  75,   5,  48, "HN" ],
[  75,  17,  38, "Da" ],
[  75,  51,  14, "BKn" ],
[  76,   7,  47, "Da" ],
[  76,   8,  46, "BKn" ],
[  76,  14,  41, "BKn" ],
[  77,  11,  44, "BKn" ],
[  77,  23,  35, "Da" ],
[  77,  39,  24, "LP" ],
[  78,  17,  40, "Da" ],
[  78,  21,  37, "LP" ],
[  78,  31,  30, "LP" ],
[  78,  37,  26, "LP" ],
[  78,  47,  19, "LP" ],
[  78,  48,  18, "LP" ],
[  78,  51,  16, "LP" ],
[  79,  14,  43, "BKn" ],
[  79,  15,  42, "Da" ],
[  79,  35,  28, "LP" ],
[  80,  11,  46, "BKn" ],
[  80,  20,  39, "Da" ],
[  80,  30,  32, "LP" ],
[  80,  47,  20, "LP" ],
[  81,  18,  41, "Da" ],
[  82,   8,  50, "BKn" ],
[  82,  14,  45, "Da" ],
[  82,  15,  44, "Da" ],
[  82,  26,  36, "Da" ],
[  82,  29,  34, "LP" ],
[  83,   6,  53, "LP" ],
[  83,  11,  48, "BKn" ],
[  83,  21,  40, "Da" ],
[  83,  24,  38, "Da" ],
[  83,  46,  23, "LP" ],
[  84,  13,  47, "LP" ],
[  84,  18,  43, "Da" ],
[  84,  44,  25, "LP" ],
[  85,   8,  52, "BKn" ],
[  85,  33,  33, "LP" ],
[  85,  36,  31, "LP" ],
[  85,  39,  29, "LP" ],
[  85,  42,  27, "LP" ],
[  86,  11,  50, "BKn" ],
[  86,  12,  49, "Da" ],
[  86,  15,  46, "Da" ],
[  86,  21,  42, "Da" ],
[  87,  18,  45, "Da" ],
[  87,  32,  35, "LP" ],
[  87,  65,  12, "sph" ],
[  87,  68,  10, "sph" ],
[  88,  27,  39, "Da" ],
[  88,  30,  37, "LP" ],
[  88,  63,  14, "sph" ],
[  89,  11,  52, "BKn" ],
[  89,  12,  51, "BKn" ],
[  89,  21,  44, "Da" ],
[  89,  25,  41, "Da" ],
[  89,  47,  26, "LP" ],
[  90,  15,  49, "Da" ],
[  91,   8,  56, "BKn" ],
[  91,  24,  43, "Da" ],
[  91,  37,  34, "LP" ],
[  91,  40,  32, "LP" ],
[  91,  46,  28, "LP" ],
[  91,  75,   8, "sph" ],
[  92,  12,  53, "Da" ],
[  92,  18,  48, "Da" ],
[  92,  22,  45, "Da" ],
[  92,  35,  36, "LP" ],
[  92,  64,  16, "sph" ],
[  93,  15,  51, "Da" ],
[  93,  30,  40, "LP" ],
[  93,  45,  30, "LP" ],
[  94,   5,  61, "HN" ],
[  94,   8,  58, "BKn" ],
[  94,  28,  42, "Da" ],
[  94,  34,  38, "LP" ],
[  94,  58,  22, "sph" ],
[  95,  11,  56, "BKn" ],
[  95,  12,  55, "BKn" ],
[  95,  18,  50, "Da" ],
[  95,  22,  47, "Da" ],
[  95,  64,  18, "sph" ],
[  96,  15,  53, "Da" ],
[  96,  27,  44, "Da" ],
[  97,   8,  60, "BKn" ],
[  97,  21,  49, "Da" ],
[  97,  25,  46, "Da" ],
[  98,   7,  62, "BKn" ],
[  98,  10,  59, "LP" ],
[  98,  11,  58, "BKn" ],
[  98,  12,  57, "BKn" ],
[  98,  18,  52, "Da" ],
[  98,  19,  51, "Da" ],
[  98,  39,  37, "LP" ],
[  98,  42,  35, "LP" ],
[  98,  45,  33, "LP" ],
[  99,  15,  55, "Da" ],
[  99,  16,  54, "Da" ],
[  99,  31,  43, "LP" ],
[  99,  34,  41, "LP" ],
[  99,  37,  39, "LP" ],
[  99,  65,  20, "sph" ],
[ 100,   8,  62, "BKn" ],
[ 100,  12,  58, "BKn" ],
[ 100,  22,  50, "Da" ],
[ 100,  25,  48, "Da" ],
[ 100,  91,   4, "sph" ],
[ 101,  10,  61, "LP" ],
[ 101,  11,  60, "BKn" ],
[ 101,  19,  53, "LP" ],
[ 101,  30,  45, "LP" ],
[ 102,  15,  57, "LP" ],
[ 102,  16,  56, "LP" ],
[ 102,  28,  47, "LP" ],
[ 103,  12,  60, "BKn" ],
[ 103,  22,  52, "LP" ],
[ 103,  26,  49, "LP" ],
[ 103,  77,  14, "sph" ],
[ 103,  80,  12, "sph" ],
[ 104,  11,  62, "BKn" ],
[ 104,  19,  55, "LP" ],
[ 104,  37,  42, "LP" ],
[ 104,  40,  40, "LP" ],
[ 104,  43,  38, "LP" ],
[ 104,  67,  22, "sph" ],
[ 104,  75,  16, "sph" ],
[ 105,  15,  59, "BKn" ],
[ 105,  16,  58, "LP" ],
[ 105,  25,  51, "LP" ],
[ 105,  35,  44, "LP" ],
[ 105,  47,  36, "LP" ],
[ 106,   8,  66, "BKn" ],
[ 106,  12,  62, "BKn" ],
[ 106,  19,  56, "LP" ],
[ 106,  22,  54, "LP" ],
[ 107,  10,  65, "LP" ],
[ 107,  11,  64, "BKn" ],
[ 107,  31,  48, "LP" ],
[ 107,  34,  46, "LP" ],
[ 107,  75,  18, "sph" ],
[ 107,  94,   6, "sph" ],
[ 108,  15,  61, "LP" ],
[ 108,  16,  60, "LP" ],
[ 108,  25,  53, "LP" ],
[ 108,  29,  50, "LP" ],
[ 108,  68,  24, "sph" ],
[ 108,  88,  10, "sph" ],
[ 109,   8,  68, "BKn" ],
[ 109,   9,  67, "BKn" ],
[ 109,  12,  64, "BKn" ],
[ 109,  19,  58, "LP" ],
[ 109,  23,  55, "LP" ],
[ 110,  11,  66, "BKn" ],
[ 110,  16,  61, "LP" ],
[ 110,  28,  52, "LP" ],
[ 110,  38,  45, "LP" ],
[ 110,  41,  43, "LP" ],
[ 110,  47,  39, "LP" ],
[ 110,  75,  20, "sph" ],
[ 111,   7,  71, "BKn" ],
[ 111,  15,  63, "LP" ],
[ 111,  22,  57, "LP" ],
[ 111,  26,  54, "LP" ],
[ 112,   8,  70, "LP" ],
[ 112,   9,  69, "LP" ],
[ 112,  12,  66, "LP" ],
[ 112,  19,  60, "LP" ],
[ 112,  34,  49, "LP" ],
[ 112,  37,  47, "LP" ],
[ 112,  46,  41, "LP" ],
[ 113,  11,  68, "LP" ],
[ 113,  14,  65, "LP" ],
[ 113,  15,  64, "LP" ],
[ 113,  16,  63, "LP" ],
[ 113,  29,  53, "LP" ],
[ 113,  32,  51, "LP" ],
[ 113,  70,  26, "sph" ],
[ 114,  22,  59, "LP" ],
[ 114,  23,  58, "LP" ],
[ 114,  26,  56, "LP" ],
[ 114,  76,  22, "sph" ],
[ 115,   9,  71, "LP" ],
[ 115,  12,  68, "LP" ],
[ 115,  13,  67, "LP" ],
[ 115,  19,  62, "LP" ],
[ 115,  20,  61, "LP" ],
[ 115,  41,  46, "LP" ],
[ 116,  11,  70, "LP" ],
[ 116,  15,  66, "LP" ],
[ 116,  16,  65, "LP" ],
[ 116,  26,  57, "LP" ],
[ 116,  29,  55, "LP" ],
[ 116,  45,  44, "LP" ],
[ 116,  51,  40, "LP" ],
[ 117,  23,  60, "LP" ],
[ 117,  37,  50, "LP" ],
[ 117,  40,  48, "LP" ],
[ 118,   8,  74, "LP" ],
[ 118,   9,  73, "LP" ],
[ 118,  12,  70, "LP" ],
[ 118,  13,  69, "LP" ],
[ 118,  19,  64, "LP" ],
[ 118,  20,  63, "LP" ],
[ 118,  32,  54, "LP" ],
[ 118,  35,  52, "LP" ],
[ 118,  72,  28, "sph" ],
[ 118,  77,  24, "sph" ],
[ 119,  11,  72, "LP" ],
[ 119,  15,  68, "LP" ],
[ 119,  16,  67, "LP" ],
[ 119,  26,  59, "LP" ],
[ 119,  51,  42, "LP" ],
[ 119,  89,  16, "sph" ],
[ 119, 102,   8, "sph" ],
[ 120,  23,  62, "LP" ],
[ 120,  87,  18, "sph" ],
[ 120,  93,  14, "sph" ],
[ 121,   8,  76, "LP" ],
[ 121,   9,  75, "LP" ],
[ 121,  12,  72, "LP" ],
[ 121,  13,  71, "LP" ],
[ 121,  19,  66, "LP" ],
[ 121,  20,  65, "LP" ],
[ 121,  29,  58, "LP" ],
[ 121,  32,  56, "LP" ],
[ 121,  45,  47, "LP" ],
[ 122,  11,  74, "LP" ],
[ 122,  15,  70, "LP" ],
[ 122,  16,  69, "LP" ],
[ 122,  17,  68, "LP" ],
[ 122,  26,  61, "LP" ],
[ 122,  40,  51, "LP" ],
[ 122,  43,  49, "LP" ],
[ 123,  19,  67, "LP" ],
[ 123,  23,  64, "LP" ],
[ 123,  38,  53, "LP" ],
[ 123,  79,  26, "sph" ],
[ 123,  87,  20, "sph" ],
[ 124,   8,  78, "LP" ],
[ 124,   9,  77, "LP" ],
[ 124,  10,  76, "LP" ],
[ 124,  12,  74, "LP" ],
[ 124,  13,  73, "LP" ],
[ 124,  16,  70, "LP" ],
[ 124,  21,  66, "LP" ],
[ 124,  29,  60, "LP" ],
[ 124,  36,  55, "LP" ],
[ 124, 100,  12, "sph" ],
[ 125,  15,  72, "LP" ],
[ 125,  23,  65, "LP" ],
[ 125,  26,  63, "LP" ],
[ 125,  27,  62, "LP" ],
[ 126,  12,  75, "LP" ],
[ 126,  19,  69, "LP" ],
[ 126,  20,  68, "LP" ],
[ 126,  32,  59, "LP" ],
[ 126,  35,  57, "LP" ],
[ 126,  87,  22, "sph" ],
[ 127,   8,  80, "LP" ],
[ 127,   9,  79, "LP" ],
[ 127,  10,  78, "LP" ],
[ 127,  16,  72, "LP" ],
[ 127,  26,  64, "LP" ],
[ 127,  30,  61, "LP" ],
[ 127,  43,  52, "LP" ],
[ 127,  46,  50, "LP" ],
[ 127,  80,  28, "sph" ],
[ 128,  15,  74, "LP" ],
[ 128,  23,  67, "LP" ],
[ 128,  41,  54, "LP" ],
[ 128,  50,  48, "LP" ],
[ 128,  76,  32, "sph" ],
[ 129,  12,  77, "LP" ],
[ 129,  13,  76, "LP" ],
[ 129,  19,  71, "LP" ],
[ 129,  20,  70, "LP" ],
[ 129,  36,  58, "LP" ],
[ 129,  39,  56, "LP" ],
[ 129,  87,  24, "sph" ],
[ 130,  10,  80, "LP" ],
[ 130,  16,  74, "LP" ],
[ 130,  26,  66, "LP" ],
[ 130,  27,  65, "LP" ],
[ 130,  30,  63, "LP" ],
[ 131,  23,  69, "LP" ],
[ 131,  24,  68, "LP" ],
[ 132,  12,  79, "LP" ],
[ 132,  13,  78, "LP" ],
[ 132,  19,  73, "LP" ],
[ 132,  20,  72, "LP" ],
[ 132,  33,  62, "LP" ],
[ 132,  36,  60, "LP" ],
[ 132,  82,  30, "sph" ]];
